"""Configuration

This module defines some constants.

This module also provides get() and set() methods to access the
configuration file.  The content of configuration file is repr()
result of a dictionary.
"""

import sys
import os

KITTYWALKPATH = os.path.abspath(sys.path[0])
DATAPATHBASE = os.path.expanduser("~/.kittywalk")
DATADIR = os.path.join(DATAPATHBASE, "data")


_config_file_path = os.path.join(DATAPATHBASE, "config")

def get(key, default=None):
    """Return configuration value associated with key"""
    data = _read_data()
    return data.get(key, default)

def set(key, value):
    """Save value associated with key"""
    data = _read_data()
    data.update({key:value})
    _write_data(data)

def _read_data():
    try:
        return eval(file(_config_file_path).read())
    except:
        return {}

def _write_data(data):
    file(_config_file_path,"w").write(repr(data))
    
