"""Installer

This module provides very simple installation utilities, for the first 
boot.  You don't have to use this module explicitly, but you may.

"""

import os
import config
import shutil

def is_required():
    """Return whether installation is required

    This function returns True if board list file is not found, False 
    otherwise.
    """
    return not os.path.exists(os.path.join(config.DATADIR,"boardtree.xml"))

def main():
    shutil.copytree(os.path.join(config.KITTYWALKPATH, "default.kittywalk"),
                    config.DATAPATHBASE)

if __name__ == "__main__":
    main()

