from qt import *
import sys
import os

from utils import *
from bbs import *
from ui import UserInterface
import install


class Application(object):
    def __init__(self, UserInterfaceClass):
        self._ui = UserInterfaceClass(self)
        self._bbs = BBS()

    def start(self):
        self._ui.start()

    def echo(self, text):
        self._ui.echo(text)

    def bbs(self):
        return self._bbs

    def topic_list(self, board):
        """Return topic list in board"""
        assert isinstance(board, Board)
        if board.is_empty():
            return self.latest_topic_list(board)
        else:
            return [t for t in board.topics()]

    def latest_topic_list(self, board):
        assert isinstance(board, Board)
        try:
            self.echo(u("ダウンロード開始: %s") % board.title())
            board.update()
        except:
            self.echo(u("ダウンロード失敗: %s") % board.title())
            if board.is_empty():
                return []
        else:
            self.echo(u("ダウンロード完了: %s") % board.title())
        return [t for t in board.topics()]

    def messages(self, topic, renderer):
        """Return messages in topic"""
        assert isinstance(topic, Topic)
        if topic.is_empty():
            return self.latest_messages(topic, renderer)
        else:
            return renderer.render(topic)

    def latest_messages(self, topic, renderer):
        assert isinstance(topic, Topic)
        try:
            self.echo(u("ダウンロード開始: %s") % topic.title())
            topic.update()
        except:
            self.echo(u("ダウンロード失敗: %s") % topic.title())
            if topic.is_empty():
                return renderer.render(topic)
        else:
            self.echo(u("ダウンロード完了: %s") % topic.title())
        return renderer.render(topic)


def main():
    if install.is_required():
        install.main()
    app = Application(UserInterface)
    app.start()

if __name__ == "__main__":
    main()

